 __     ____      ____   ______      ___   ____  ____  
 /  |  .'    '.  .'    '.|_   _ `.  .'   `.|_   ||   _| 
 `| | |  .--.  ||  .--.  | | | `. \/  .-.  \ | |__| |   
  | | | |    | || |    | | | |  | || |   | | |  __  |   
 _| |_|  `--'  ||  `--'  |_| |_.' /\  `-'  /_| |  | |_  
|_____|'.____.'  '.____.'|______.'  `.___.'|____||____| 
                                                        

-------------------------------------------------------------------------------
Dandan Shan, Jiaqi Geng*, Michelle Shu*, David F. Fouhey
Understanding Human Hands in Contact at Internet Scale
By using this data, you agree to be bound by the 100DOH agreement.
Contact: dandans@umich.edu
-------------------------------------------------------------------------------


0. About

This package contains version 1.0 of the metadata and labels for
the 100DOH dataset. We may release additional labels based on community interest.

You need to download frames and videos separately.

Version history:
    v1.0 (June 2020): 
        initial release


1. Files

(1) -- meta_100DOH_video.txt 
For each video, it provides video id (from YouTube), genre (in total 12) as well as duration (second), resolution, frame rate, frame number, and creation time (if provided) that extracted using ffprobe. 

You can get video link on YouTube by video id, e.g. https://www.youtube.com/watch?v={video id}
You can use youtube-dl package (https://github.com/ytdl-org/youtube-dl) to download videos.

(2) -- meta_100K_frame.txt
For each frame, it provides image name ({genre}_v_{video id}_frame{frame index}.jpg), video id (from YouTube), frame index (start from 1), genre as well as duration (second), resolution, frame rate, frame number and creation time (if provided) that get by using ffprobe. We provide details for our users to make it possible to create the 100K frame dataset on your own from videos. 

Initially, it contains 100K (train:val:test=80K:10K:10K) frames. However, when we went through the frames, we observed some objectionable ones and we decided to deleted the 101 objectionable ones we found. Right now, the frame dataset contains 99899 (train:val:test=79921:9995:9983) frames. This dataset is enormous and it is impossible to analyze everything. We have done our best but are committed to making the dataset as good as possible. Please email us with any issues. 

we used this ffmpeg commend to decode frames:
    "ffmpeg -i video_path -vf fps=0.5 -qscale:v 2 dst_dir/frame%06d.jpg"


(3) -- train/trainval/val/test.json
These are split annotation files. Here is an example:

    "test/diy/diy_v_yW_Xdvl3PmQ_frame000023.jpg": [
        {
            "x1": 0.006617646910327531,
            "y1": 0.001960784269726743,
            "x2": 0.6546663851351352,
            "y2": 0.7347972972972973,
            "contact_state": 3,
            "hand_side": "l",
            "width": 1280,
            "height": 720,
            "obj_bbox": {
                "x1": 0.38203125,
                "y1": 0.12916666666666668,
                "x2": 0.815625,
                "y2": 0.9944444444444445
            }
        }
    ]

    key: image path (in raw.zip file)
    value: a list of annotations for hands in the image
    annotation for each hand:
        (a) x1, y1, x2, y2: hand location represented by top left (x1, y1) and bottom right (x2, y2) points via ratio to width and height. For example, (0,0,1,1) will cover the whole image, (0,1/2,1,1) covers the bottom half of the image.

        (b) contact_state: {0:"No Contact", 1:"Self Contact", 2:"Another Person", 3:"Portable Object", 4:"Stationary Object"}
        (c) hand_side: {0:"Left", 1:"Right"}
        (d) width, height
        (e) obj_box: object location, only for the one object that in contact with the hand if it exists


Please pay attention to the relation between the contact state and object box. These were annotated **independently**. This means that the annotation does not guarantee that each hand that is labeled as in-contact has a corresponding object box. It only guarantees that no-contact hands do not have object boxes. We are providing the raw judgments in case you are training on only a subset of labels. You are free to post-process however you please. During our training, we use the inconsistent labels so that any in-contact labeled hand has an offset vector prediction, pointing to an object.  



